package org.objectweb.jonathan.helpers;

import junit.framework.*;

import org.objectweb.jonathan.apis.kernel.JonathanException;

import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.Element;
import org.objectweb.jonathan.apis.kernel.MultiFactory;
import org.objectweb.jonathan.apis.kernel.ClassPathFinder;
import org.objectweb.jonathan.apis.kernel.decoders.File2Configuration;

import org.objectweb.jonathan.libs.kernel.JConfigurationFactory;

import org.objectweb.jonathan.libs.kernel.decoders.JAtom;

import java.util.*;

public class CollectionFactoryTest extends TestCase {

   Context theContext = null;

   public CollectionFactoryTest(String name) {
      super(name);
      theContext = this.getContext();
   }

	public static void main(String args[]) {
		junit.textui.TestRunner.run(CollectionFactoryTest.class);
	}   

   protected void setUp() {
   }
   
   public void testHashtable() {
      try {         
         Object $object = theContext.getValue("/Hashtable",'/');
         assert($object + " is not a Hashtable", $object instanceof Hashtable);
         Hashtable aHash = (Hashtable)$object;
         assertEquals("hello", aHash.get("h"));
         assertEquals("world", aHash.get("w"));

         $object = theContext.getValue("/Hashtable2",'/');
         assert($object + " is not a Hashtable", $object instanceof Hashtable);
         aHash = (Hashtable)$object;
         assertEquals("hello", aHash.get("h"));
         assertEquals("world", aHash.get("w"));

      } catch (ClassCastException ccex) {
         ccex.printStackTrace();
         fail("Elements typing error");
      }
   }
   
   public void testHashMap() {
      try {         
         Object $object = theContext.getValue("/HashMap",'/');
         assert($object + " is not a HashMap", $object instanceof HashMap);
         Map aMap = (HashMap)$object;
         assertEquals("hello", aMap.get("h"));
         assertEquals("world", aMap.get("w"));

         $object = theContext.getValue("/HashMap2",'/');
         assert($object + " is not a HashMap", $object instanceof HashMap);
         aMap = (HashMap)$object;
         assertEquals("hello", aMap.get("h"));
         assertEquals("world", aMap.get("w"));

      } catch (ClassCastException ccex) {
         ccex.printStackTrace();
         fail("Elements typing error");
      }
   }   

   public void testHashSet() {
      try {         
         Object $object = theContext.getValue("/HashSet",'/');
         assert($object + " is not a HashSet", $object instanceof HashSet);
         HashSet aSet = (HashSet)$object;
         assert(aSet.contains("hello"));
         assert(aSet.contains("world"));
      } catch (ClassCastException ccex) {
         ccex.printStackTrace();
         fail("Elements typing error");
      }
   }   

   public void testVector() {
      try {         
         Object $object = theContext.getValue("/Vector",'/');
         assert($object + " is not a Vector", $object instanceof Vector);
         Vector aVector = (Vector)$object;
         assertEquals(aVector.elementAt(0),"hello");
         assertEquals(aVector.elementAt(1),"world");
      } catch (ClassCastException ccex) {
         ccex.printStackTrace();
         fail("Elements typing error");
      }
   }   

   public void testArrayList() {
      try {         
         Object $object = theContext.getValue("/ArrayList",'/');
         assert($object + " is not a ArrayList", $object instanceof ArrayList);
         ArrayList aList = (ArrayList)$object;
         assertEquals(aList.get(0),"hello");
         assertEquals(aList.get(1),"world");
      } catch (ClassCastException ccex) {
         ccex.printStackTrace();
         fail("Elements typing error");
      }
   }   

   private Context getContext() {
      try {
         
         Context $initial_context = BootKernel.newConfiguration(CollectionFactoryTest.class);
         ClassPathFinder $finder = (ClassPathFinder) $initial_context.getValue("classpath_finder",(char) 0);
         File2Configuration $decoder = (File2Configuration) 
            $initial_context.getValue("jonathan/decoders/OpenXMLDecoder/instance",'/');
      
         JConfigurationFactory $context_factory = new JConfigurationFactory();
      
         Context $context = $context_factory.newContext(null,$finder);
      
         $decoder.importElement($context,
                                "org/objectweb/jonathan/helpers/CollectionFactoryTest.kcf",
                                $context_factory,
                                $finder);
         return $context;
      } catch (Exception e) {
         e.printStackTrace();
         return null;
      }
   }
}




