package org.objectweb.jonathan.libs.kernel;

import junit.framework.*;

import org.objectweb.jonathan.apis.kernel.Context;

import java.util.Enumeration;

public class JContextFactoryTest extends TestCase {

   public JContextFactoryTest(String name) {
      super(name);
   }

	public static void main(String args[]) {
		junit.textui.TestRunner.run(JContextFactoryTest.class);
	}
   
   public void testGetElementAtRoot() {
      try {
         
         JConfigurationFactory $context_factory = new JConfigurationFactory();
         Context $context = $context_factory.newContext();

         Object $object1 =  new Object();

         $context.addElement("toto",Object.class,$object1,(char) 0);
         
         assertSame($context.getValue("toto",(char) 0),$object1);
         assertSame($context.getValue("/toto",'/'),$object1);
         
      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }
   
      

   public void testAddElementSameHashCode() {
      try {
         
         JContextFactory $context_factory = new JContextFactory();
         Context $context = $context_factory.newContext();

         String $key1 = new String(new char[] { (char) 1, (char) 0 });
         String $key2 = new String(new char[] { (char) 31 });

         assertEquals("Keys should have the same hashcode.",$key1.hashCode(),$key2.hashCode());

         Object $object1 =  new Object();
         Object $object2 =  new Object();

         $context.addElement($key1,Object.class,$object1,(char) 0);
         $context.addElement($key2,Object.class,$object2,(char) 0);

         assertSame($context.getValue($key1,(char) 0),$object1);
         assertSame($context.getValue($key2,(char) 0),$object2);

      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }
   
   public void testListElementHashCodeMod7Eq6() {
      try {
         
         JContextFactory $context_factory = new JContextFactory();
         Context $context = $context_factory.newContext();

         String $key1 = "0";
         String $key2 = "201";

         assertEquals("hashcode1 modulo 7 != 6.",6,($key1.hashCode() % 7) & 0xFFFFFFF);
         assertEquals("hashcode1 modulo 7 != 6.",6,($key2.hashCode() % 7) & 0xFFFFFFF);

         Object $object1 =  new Object();
         Object $object2 =  new Object();

         $context.addElement($key1,Object.class,$object1,(char) 0);
         $context.addElement($key2,Object.class,$object2,(char) 0);
         
         int count = 0;
         for (Enumeration $e = $context.getElements(); $e.hasMoreElements();) {
            $e.nextElement();
            count++;
         }
         assertEquals("Should have 2 elements in context.",2,count);
      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }
}

