package org.objectweb.jonathan.libs.kernel.decoders;

import junit.framework.*;

import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.Element;
import org.objectweb.jonathan.apis.kernel.MultiFactory;
import org.objectweb.jonathan.apis.kernel.ClassPathFinder;
import org.objectweb.jonathan.apis.kernel.decoders.File2Configuration;

import org.objectweb.jonathan.libs.kernel.JConfigurationFactory;

import org.objectweb.jonathan.libs.kernel.decoders.JAtom;

import java.util.Enumeration;
import java.util.Properties;


public class AbstractFactoryTest extends TestCase {

   Context theContext = null;

   public AbstractFactoryTest(String name) {
      super(name);
      theContext = this.getContext();
   }

	public static void main(String args[]) {
		junit.textui.TestRunner.run(AbstractFactoryTest.class);
	}   

   protected void setUp() {

   }
   
   public void testAbstractFactory() {
      try {         
         Object $object = theContext.getValue("assemblage",(char) 0);
         assert("Abstract factory doesn't work: wrong type ! ("+$object.getClass()+")", $object instanceof TypeB);
         TypeB $b = (TypeB)$object;
         assertEquals(5, $b.getParam());

      } catch (ClassCastException ccex) {
         ccex.printStackTrace();
         fail("Elements typing error");
      }catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }   

   public Context getContext() {
      try {
         
         Context $initial_context = BootKernel.newConfiguration(SequenceTest.class);
         ClassPathFinder $finder = (ClassPathFinder) $initial_context.getValue("classpath_finder",(char) 0);
         File2Configuration $decoder = (File2Configuration) 
            $initial_context.getValue("jonathan/decoders/OpenXMLDecoder/instance",'/');
      
         JConfigurationFactory $context_factory = new JConfigurationFactory();
      
         Context $context = $context_factory.newContext(null,$finder);
      
         $decoder.importElement($context,
                                "org/objectweb/jonathan/libs/kernel/decoders/AbstractFactory.kcf",
                                $context_factory,
                                $finder);
         return $context;
      } catch (Exception e) {
         e.printStackTrace();
         return null;
      }
   }
}




