package org.objectweb.jonathan.libs.kernel.decoders;

import junit.framework.*;

import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.Element;
import org.objectweb.jonathan.apis.kernel.MultiFactory;
import org.objectweb.jonathan.apis.kernel.ClassPathFinder;
import org.objectweb.jonathan.apis.kernel.decoders.File2Configuration;

import org.objectweb.jonathan.libs.kernel.JConfigurationFactory;

import org.objectweb.jonathan.libs.kernel.decoders.JAtom;

import java.util.Enumeration;
import java.util.Properties;


public class ImplicitFactoriesTest extends TestCase {

   public ImplicitFactoriesTest(String name) {
      super(name);
   }

   /** 
    * used by the test
    */
   public ImplicitFactoriesTest() {
      super("");
   }

	public static void main(String args[]) {
		junit.textui.TestRunner.run(ImplicitFactoriesTest.class);
	}   

   public void testImportXML() {
      try {
         Context $initial_context = BootKernel.newConfiguration(ImplicitFactoriesTest.class);
         ClassPathFinder $finder = (ClassPathFinder) $initial_context.getValue("classpath_finder",(char) 0);
         File2Configuration $decoder = (File2Configuration) 
            $initial_context.getValue("jonathan/decoders/OpenXMLDecoder/instance",'/');
         
         JConfigurationFactory $context_factory = new JConfigurationFactory();

         Context $context = $context_factory.newContext(null,$finder);
         
         $decoder.importElement($context,
                                "org/objectweb/jonathan/libs/kernel/decoders/ImplicitFactories.kcf",
                                $context_factory,
                                $finder);
         actualTest($context);
      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }
   
   public void testGenerated() {
      try {         
         actualTest(ImplicitFactories.newConfiguration(ImplicitFactoriesTest.class));
      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }

   void actualTest(Context _context) {
      try {         
         Object $toto_factory = _context.getValue("toto_factory",(char) 0);
         assert("toto_factory is not a MultiFactory", $toto_factory instanceof MultiFactory);

         Object $component0 = _context.getValue("implicit_assemblage",(char) 0);
         if ($component0 instanceof Toto) {
            assertEquals(((Toto) $component0).getIntValue(),0);
            assertEquals(((Toto) $component0).getToto(),null);
         } else {
            assert("implicit_assemblage is not a Toto", false);         
         }

         Object $component1 = _context.getValue("implicit_assemblage1",(char) 0);
         if ($component1 instanceof Toto) {
            assertEquals(((Toto) $component1).getIntValue(),12);
            assertEquals(((Toto) $component1).getToto(),null);
         } else {
            assert("implicit_assemblage1 is not a Toto", false);         
         }

         Object $component2 = _context.getValue("implicit_assemblage2",(char) 0);
         if ($component2 instanceof Toto) {
            assertEquals(((Toto) $component2).getIntValue(),12);
            assertSame(((Toto) $component2).getToto(),$component0);
         } else {
            assert("implicit_assemblage2 is not a Toto", false);         
         }

         Object $tata_factory = _context.getValue("tata_factory",(char) 0);
         assert("tata_factory is not a MultiFactory", $tata_factory instanceof MultiFactory);

         Object $component3 = _context.getValue("implicit_assemblage3",(char) 0);
         assert("implicit_assemblage3 is not a Tata but a "+$component3.getClass(), $component3 instanceof Tata);

         try {
            Object $bad_assemblage = _context.getValue("bad_implicit_assemblage",(char) 0);
            
         } catch (Exception _ex) {
            _ex.printStackTrace();
            fail("TargetInvocationException not catched, test fails.");
         }
      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }
}
