/***
 * Jonathan: an Open Distributed Processing Environment 
 * Copyright (C) 2001 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: jonathan@objectweb.org
 *
 * Author: Bruno Dumant
 *
 * --------------------------------------------------------------------------
 * $Id: File2Configuration.java,v 1.1.1.1 2002/08/06 13:13:47 bmi Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonathan.apis.kernel.decoders;

import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.ContextFactory;
import org.objectweb.jonathan.apis.kernel.JonathanException;
import org.objectweb.jonathan.apis.kernel.ClassPathFinder;

/**
 * XML file to runtime configuration import interface.
 */
public interface File2Configuration {
   
   /** 
    * Imports the provided configuration file into the
    * <code>configuration</code>.
    *
    * @param configuration the context to import the file to
    * @param file_name the XML configuration file to import
    * @param context_factory used to create contexts while importing
    * @param finder used to find the XML configuration files to be
    * imported (the provided one, and those it includes)
    * @throws JonathanException if something goes wrong
    */
   void importElement(Context configuration, String file_name, ContextFactory context_factory,
                      ClassPathFinder finder)
      throws JonathanException;
}
   
