/***
 * Jonathan: an Open Distributed Processing Environment 
 * Copyright (C) 2001 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: jonathan@objectweb.org
 *
 * Author: Bruno Dumant
 *
 * -------------------------------------------------------------------
 * $Id: XMLElementDecoder.java,v 1.1.1.1 2002/08/06 13:13:55 bmi Exp $
 * -------------------------------------------------------------------
 * 
 */

package org.objectweb.jonathan.libs.kernel.decoders;

import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.Component;
import org.objectweb.jonathan.apis.kernel.JonathanException;

import nanoxml.XMLElement;

/**
 * Generic XML to runtime component decoder interface.
 * A set of <code>XMLElementDecoder</code> implementations are held
 * by the {@link OpenXMLDecoder} as its built-in XML decoders.
 * Additional <code>XMLElementDecoder</code> implementations
 * may be provided by passing it in the {@link OpenXMLDecoder}
 * constructor's {@link Context} parameter.
 * @see OpenXMLDecoder
 */
public interface XMLElementDecoder {
   
   Component decode(XMLElement _xml_element, String _element_name, Context _configuration,
                    XMLElementDecoderDispatcher _dispatcher) 
      throws JonathanException;
}
